package com.jcraft.jorbis;

import com.jcraft.jogg.Buffer;

/* loaded from: com_jcraft_jorbis.jar:com/jcraft/jorbis/CodeBook.class */
class CodeBook {
    int dim;
    int entries;
    float[] valuelist;
    int[] codelist;
    DecodeAux decode_tree;
    StaticCodeBook c = new StaticCodeBook();
    private int[] t = new int[15];

    int encode(int i, Buffer buffer) {
        buffer.write(this.codelist[i], this.c.lengthlist[i]);
        return this.c.lengthlist[i];
    }

    int errorv(float[] fArr) {
        int best = best(fArr, 1);
        for (int i = 0; i < this.dim; i++) {
            fArr[i] = this.valuelist[(best * this.dim) + i];
        }
        return best;
    }

    int encodev(int i, float[] fArr, Buffer buffer) {
        for (int i2 = 0; i2 < this.dim; i2++) {
            fArr[i2] = this.valuelist[(i * this.dim) + i2];
        }
        return encode(i, buffer);
    }

    int encodevs(float[] fArr, Buffer buffer, int i, int i2) {
        return encode(besterror(fArr, i, i2), buffer);
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public synchronized int decodevs_add(float[] fArr, int i, Buffer buffer, int i2) {
        int i3 = i2 / this.dim;
        if (this.t.length < i3) {
            this.t = new int[i3];
        }
        for (int i4 = 0; i4 < i3; i4++) {
            int decode = decode(buffer);
            if (decode == -1) {
                return -1;
            }
            this.t[i4] = decode * this.dim;
        }
        int i5 = 0;
        int i6 = 0;
        while (true) {
            int i7 = i6;
            if (i5 < this.dim) {
                for (int i8 = 0; i8 < i3; i8++) {
                    int i9 = i + i7 + i8;
                    fArr[i9] = fArr[i9] + this.valuelist[this.t[i8] + i5];
                }
                i5++;
                i6 = i7 + i3;
            } else {
                return 0;
            }
        }
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* JADX WARN: Failed to find 'out' block for switch in B:24:0x007c. Please report as an issue. */
    public int decodev_add(float[] fArr, int i, Buffer buffer, int i2) {
        if (this.dim > 8) {
            int i3 = 0;
            while (i3 < i2) {
                int decode = decode(buffer);
                if (decode == -1) {
                    return -1;
                }
                int i4 = decode * this.dim;
                int i5 = 0;
                while (i5 < this.dim) {
                    int i6 = i3;
                    i3++;
                    int i7 = i + i6;
                    int i8 = i5;
                    i5++;
                    fArr[i7] = fArr[i7] + this.valuelist[i4 + i8];
                }
            }
            return 0;
        }
        int i9 = 0;
        while (i9 < i2) {
            int decode2 = decode(buffer);
            if (decode2 == -1) {
                return -1;
            }
            int i10 = decode2 * this.dim;
            int i11 = 0;
            switch (this.dim) {
                case 1:
                    int i12 = i9;
                    i9++;
                    int i13 = i + i12;
                    int i14 = i11;
                    int i15 = i11 + 1;
                    fArr[i13] = fArr[i13] + this.valuelist[i10 + i14];
                    break;
                case 2:
                    int i16 = i9;
                    i9++;
                    int i17 = i + i16;
                    int i18 = i11;
                    i11++;
                    fArr[i17] = fArr[i17] + this.valuelist[i10 + i18];
                    int i122 = i9;
                    i9++;
                    int i132 = i + i122;
                    int i142 = i11;
                    int i152 = i11 + 1;
                    fArr[i132] = fArr[i132] + this.valuelist[i10 + i142];
                    break;
                case 3:
                    int i19 = i9;
                    i9++;
                    int i20 = i + i19;
                    int i21 = i11;
                    i11++;
                    fArr[i20] = fArr[i20] + this.valuelist[i10 + i21];
                    int i162 = i9;
                    i9++;
                    int i172 = i + i162;
                    int i182 = i11;
                    i11++;
                    fArr[i172] = fArr[i172] + this.valuelist[i10 + i182];
                    int i1222 = i9;
                    i9++;
                    int i1322 = i + i1222;
                    int i1422 = i11;
                    int i1522 = i11 + 1;
                    fArr[i1322] = fArr[i1322] + this.valuelist[i10 + i1422];
                    break;
                case 4:
                    int i22 = i9;
                    i9++;
                    int i23 = i + i22;
                    int i24 = i11;
                    i11++;
                    fArr[i23] = fArr[i23] + this.valuelist[i10 + i24];
                    int i192 = i9;
                    i9++;
                    int i202 = i + i192;
                    int i212 = i11;
                    i11++;
                    fArr[i202] = fArr[i202] + this.valuelist[i10 + i212];
                    int i1622 = i9;
                    i9++;
                    int i1722 = i + i1622;
                    int i1822 = i11;
                    i11++;
                    fArr[i1722] = fArr[i1722] + this.valuelist[i10 + i1822];
                    int i12222 = i9;
                    i9++;
                    int i13222 = i + i12222;
                    int i14222 = i11;
                    int i15222 = i11 + 1;
                    fArr[i13222] = fArr[i13222] + this.valuelist[i10 + i14222];
                    break;
                case 5:
                    int i25 = i9;
                    i9++;
                    int i26 = i + i25;
                    int i27 = i11;
                    i11++;
                    fArr[i26] = fArr[i26] + this.valuelist[i10 + i27];
                    int i222 = i9;
                    i9++;
                    int i232 = i + i222;
                    int i242 = i11;
                    i11++;
                    fArr[i232] = fArr[i232] + this.valuelist[i10 + i242];
                    int i1922 = i9;
                    i9++;
                    int i2022 = i + i1922;
                    int i2122 = i11;
                    i11++;
                    fArr[i2022] = fArr[i2022] + this.valuelist[i10 + i2122];
                    int i16222 = i9;
                    i9++;
                    int i17222 = i + i16222;
                    int i18222 = i11;
                    i11++;
                    fArr[i17222] = fArr[i17222] + this.valuelist[i10 + i18222];
                    int i122222 = i9;
                    i9++;
                    int i132222 = i + i122222;
                    int i142222 = i11;
                    int i152222 = i11 + 1;
                    fArr[i132222] = fArr[i132222] + this.valuelist[i10 + i142222];
                    break;
                case 6:
                    int i28 = i9;
                    i9++;
                    int i29 = i + i28;
                    int i30 = i11;
                    i11++;
                    fArr[i29] = fArr[i29] + this.valuelist[i10 + i30];
                    int i252 = i9;
                    i9++;
                    int i262 = i + i252;
                    int i272 = i11;
                    i11++;
                    fArr[i262] = fArr[i262] + this.valuelist[i10 + i272];
                    int i2222 = i9;
                    i9++;
                    int i2322 = i + i2222;
                    int i2422 = i11;
                    i11++;
                    fArr[i2322] = fArr[i2322] + this.valuelist[i10 + i2422];
                    int i19222 = i9;
                    i9++;
                    int i20222 = i + i19222;
                    int i21222 = i11;
                    i11++;
                    fArr[i20222] = fArr[i20222] + this.valuelist[i10 + i21222];
                    int i162222 = i9;
                    i9++;
                    int i172222 = i + i162222;
                    int i182222 = i11;
                    i11++;
                    fArr[i172222] = fArr[i172222] + this.valuelist[i10 + i182222];
                    int i1222222 = i9;
                    i9++;
                    int i1322222 = i + i1222222;
                    int i1422222 = i11;
                    int i1522222 = i11 + 1;
                    fArr[i1322222] = fArr[i1322222] + this.valuelist[i10 + i1422222];
                    break;
                case 7:
                    int i31 = i9;
                    i9++;
                    int i32 = i + i31;
                    int i33 = i11;
                    i11++;
                    fArr[i32] = fArr[i32] + this.valuelist[i10 + i33];
                    int i282 = i9;
                    i9++;
                    int i292 = i + i282;
                    int i302 = i11;
                    i11++;
                    fArr[i292] = fArr[i292] + this.valuelist[i10 + i302];
                    int i2522 = i9;
                    i9++;
                    int i2622 = i + i2522;
                    int i2722 = i11;
                    i11++;
                    fArr[i2622] = fArr[i2622] + this.valuelist[i10 + i2722];
                    int i22222 = i9;
                    i9++;
                    int i23222 = i + i22222;
                    int i24222 = i11;
                    i11++;
                    fArr[i23222] = fArr[i23222] + this.valuelist[i10 + i24222];
                    int i192222 = i9;
                    i9++;
                    int i202222 = i + i192222;
                    int i212222 = i11;
                    i11++;
                    fArr[i202222] = fArr[i202222] + this.valuelist[i10 + i212222];
                    int i1622222 = i9;
                    i9++;
                    int i1722222 = i + i1622222;
                    int i1822222 = i11;
                    i11++;
                    fArr[i1722222] = fArr[i1722222] + this.valuelist[i10 + i1822222];
                    int i12222222 = i9;
                    i9++;
                    int i13222222 = i + i12222222;
                    int i14222222 = i11;
                    int i15222222 = i11 + 1;
                    fArr[i13222222] = fArr[i13222222] + this.valuelist[i10 + i14222222];
                    break;
                case 8:
                    int i34 = i9;
                    i9++;
                    int i35 = i + i34;
                    i11 = 0 + 1;
                    fArr[i35] = fArr[i35] + this.valuelist[i10 + 0];
                    int i312 = i9;
                    i9++;
                    int i322 = i + i312;
                    int i332 = i11;
                    i11++;
                    fArr[i322] = fArr[i322] + this.valuelist[i10 + i332];
                    int i2822 = i9;
                    i9++;
                    int i2922 = i + i2822;
                    int i3022 = i11;
                    i11++;
                    fArr[i2922] = fArr[i2922] + this.valuelist[i10 + i3022];
                    int i25222 = i9;
                    i9++;
                    int i26222 = i + i25222;
                    int i27222 = i11;
                    i11++;
                    fArr[i26222] = fArr[i26222] + this.valuelist[i10 + i27222];
                    int i222222 = i9;
                    i9++;
                    int i232222 = i + i222222;
                    int i242222 = i11;
                    i11++;
                    fArr[i232222] = fArr[i232222] + this.valuelist[i10 + i242222];
                    int i1922222 = i9;
                    i9++;
                    int i2022222 = i + i1922222;
                    int i2122222 = i11;
                    i11++;
                    fArr[i2022222] = fArr[i2022222] + this.valuelist[i10 + i2122222];
                    int i16222222 = i9;
                    i9++;
                    int i17222222 = i + i16222222;
                    int i18222222 = i11;
                    i11++;
                    fArr[i17222222] = fArr[i17222222] + this.valuelist[i10 + i18222222];
                    int i122222222 = i9;
                    i9++;
                    int i132222222 = i + i122222222;
                    int i142222222 = i11;
                    int i152222222 = i11 + 1;
                    fArr[i132222222] = fArr[i132222222] + this.valuelist[i10 + i142222222];
                    break;
            }
        }
        return 0;
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public int decodev_set(float[] fArr, int i, Buffer buffer, int i2) {
        int i3 = 0;
        while (i3 < i2) {
            int decode = decode(buffer);
            if (decode == -1) {
                return -1;
            }
            int i4 = decode * this.dim;
            int i5 = 0;
            while (i5 < this.dim) {
                int i6 = i3;
                i3++;
                int i7 = i5;
                i5++;
                fArr[i + i6] = this.valuelist[i4 + i7];
            }
        }
        return 0;
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public int decodevv_add(float[][] fArr, int i, int i2, Buffer buffer, int i3) {
        int i4 = 0;
        int i5 = i / i2;
        while (i5 < (i + i3) / i2) {
            int decode = decode(buffer);
            if (decode == -1) {
                return -1;
            }
            int i6 = decode * this.dim;
            for (int i7 = 0; i7 < this.dim; i7++) {
                int i8 = i4;
                i4++;
                float[] fArr2 = fArr[i8];
                int i9 = i5;
                fArr2[i9] = fArr2[i9] + this.valuelist[i6 + i7];
                if (i4 == i2) {
                    i4 = 0;
                    i5++;
                }
            }
        }
        return 0;
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public int decode(Buffer buffer) {
        int i = 0;
        DecodeAux decodeAux = this.decode_tree;
        int look = buffer.look(decodeAux.tabn);
        if (look >= 0) {
            i = decodeAux.tab[look];
            buffer.adv(decodeAux.tabl[look]);
            if (i <= 0) {
                return -i;
            }
        }
        do {
            switch (buffer.read1()) {
                case -1:
                default:
                    return -1;
                case 0:
                    i = decodeAux.ptr0[i];
                    break;
                case 1:
                    i = decodeAux.ptr1[i];
                    break;
            }
        } while (i > 0);
        return -i;
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public int decodevs(float[] fArr, int i, Buffer buffer, int i2, int i3) {
        int decode = decode(buffer);
        if (decode == -1) {
            return -1;
        }
        switch (i3) {
            case -1:
                int i4 = 0;
                int i5 = 0;
                while (true) {
                    int i6 = i5;
                    if (i4 >= this.dim) {
                        break;
                    } else {
                        fArr[i + i6] = this.valuelist[(decode * this.dim) + i4];
                        i4++;
                        i5 = i6 + i2;
                    }
                }
            case 0:
                int i7 = 0;
                int i8 = 0;
                while (true) {
                    int i9 = i8;
                    if (i7 >= this.dim) {
                        break;
                    } else {
                        int i10 = i + i9;
                        fArr[i10] = fArr[i10] + this.valuelist[(decode * this.dim) + i7];
                        i7++;
                        i8 = i9 + i2;
                    }
                }
            case 1:
                int i11 = 0;
                int i12 = 0;
                while (true) {
                    int i13 = i12;
                    if (i11 >= this.dim) {
                        break;
                    } else {
                        int i14 = i + i13;
                        fArr[i14] = fArr[i14] * this.valuelist[(decode * this.dim) + i11];
                        i11++;
                        i12 = i13 + i2;
                    }
                }
        }
        return decode;
    }

    int best(float[] fArr, int i) {
        int i2 = -1;
        float f = 0.0f;
        int i3 = 0;
        for (int i4 = 0; i4 < this.entries; i4++) {
            if (this.c.lengthlist[i4] > 0) {
                float dist = dist(this.dim, this.valuelist, i3, fArr, i);
                if (i2 == -1 || dist < f) {
                    f = dist;
                    i2 = i4;
                }
            }
            i3 += this.dim;
        }
        return i2;
    }

    int besterror(float[] fArr, int i, int i2) {
        int best = best(fArr, i);
        switch (i2) {
            case 0:
                int i3 = 0;
                int i4 = 0;
                while (true) {
                    int i5 = i4;
                    if (i3 >= this.dim) {
                        break;
                    } else {
                        fArr[i5] = fArr[i5] - this.valuelist[(best * this.dim) + i3];
                        i3++;
                        i4 = i5 + i;
                    }
                }
            case 1:
                int i6 = 0;
                int i7 = 0;
                while (true) {
                    int i8 = i7;
                    if (i6 >= this.dim) {
                        break;
                    } else {
                        float f = this.valuelist[(best * this.dim) + i6];
                        if (f == 0.0f) {
                            fArr[i8] = 0.0f;
                        } else {
                            fArr[i8] = fArr[i8] / f;
                        }
                        i6++;
                        i7 = i8 + i;
                    }
                }
        }
        return best;
    }

    void clear() {
    }

    private static float dist(int i, float[] fArr, int i2, float[] fArr2, int i3) {
        float f = 0.0f;
        for (int i4 = 0; i4 < i; i4++) {
            float f2 = fArr[i2 + i4] - fArr2[i4 * i3];
            f += f2 * f2;
        }
        return f;
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public int init_decode(StaticCodeBook staticCodeBook) {
        this.c = staticCodeBook;
        this.entries = staticCodeBook.entries;
        this.dim = staticCodeBook.dim;
        this.valuelist = staticCodeBook.unquantize();
        this.decode_tree = make_decode_tree();
        if (this.decode_tree == null) {
            clear();
            return -1;
        }
        return 0;
    }

    static int[] make_words(int[] iArr, int i) {
        int[] iArr2 = new int[33];
        int[] iArr3 = new int[i];
        for (int i2 = 0; i2 < i; i2++) {
            int i3 = iArr[i2];
            if (i3 > 0) {
                int i4 = iArr2[i3];
                if (i3 < 32 && (i4 >>> i3) != 0) {
                    return null;
                }
                iArr3[i2] = i4;
                int i5 = i3;
                while (true) {
                    if (i5 <= 0) {
                        break;
                    }
                    if ((iArr2[i5] & 1) != 0) {
                        if (i5 == 1) {
                            iArr2[1] = iArr2[1] + 1;
                        } else {
                            iArr2[i5] = iArr2[i5 - 1] << 1;
                        }
                    } else {
                        int i6 = i5;
                        iArr2[i6] = iArr2[i6] + 1;
                        i5--;
                    }
                }
                for (int i7 = i3 + 1; i7 < 33 && (iArr2[i7] >>> 1) == i4; i7++) {
                    i4 = iArr2[i7];
                    iArr2[i7] = iArr2[i7 - 1] << 1;
                }
            }
        }
        for (int i8 = 0; i8 < i; i8++) {
            int i9 = 0;
            for (int i10 = 0; i10 < iArr[i8]; i10++) {
                i9 = (i9 << 1) | ((iArr3[i8] >>> i10) & 1);
            }
            iArr3[i8] = i9;
        }
        return iArr3;
    }

    DecodeAux make_decode_tree() {
        int i;
        int i2;
        int i3 = 0;
        DecodeAux decodeAux = new DecodeAux();
        int[] iArr = new int[this.entries * 2];
        decodeAux.ptr0 = iArr;
        int[] iArr2 = new int[this.entries * 2];
        decodeAux.ptr1 = iArr2;
        int[] make_words = make_words(this.c.lengthlist, this.c.entries);
        if (make_words == null) {
            return null;
        }
        decodeAux.aux = this.entries * 2;
        for (int i4 = 0; i4 < this.entries; i4++) {
            if (this.c.lengthlist[i4] > 0) {
                int i5 = 0;
                int i6 = 0;
                while (i6 < this.c.lengthlist[i4] - 1) {
                    if (((make_words[i4] >>> i6) & 1) == 0) {
                        if (iArr[i5] == 0) {
                            i3++;
                            iArr[i5] = i3;
                        }
                        i2 = iArr[i5];
                    } else {
                        if (iArr2[i5] == 0) {
                            i3++;
                            iArr2[i5] = i3;
                        }
                        i2 = iArr2[i5];
                    }
                    i5 = i2;
                    i6++;
                }
                if (((make_words[i4] >>> i6) & 1) == 0) {
                    iArr[i5] = -i4;
                } else {
                    iArr2[i5] = -i4;
                }
            }
        }
        decodeAux.tabn = Util.ilog(this.entries) - 4;
        if (decodeAux.tabn < 5) {
            decodeAux.tabn = 5;
        }
        int i7 = 1 << decodeAux.tabn;
        decodeAux.tab = new int[i7];
        decodeAux.tabl = new int[i7];
        for (int i8 = 0; i8 < i7; i8++) {
            int i9 = 0;
            int i10 = 0;
            while (i10 < decodeAux.tabn && (i9 > 0 || i10 == 0)) {
                if ((i8 & (1 << i10)) != 0) {
                    i = iArr2[i9];
                } else {
                    i = iArr[i9];
                }
                i9 = i;
                i10++;
            }
            decodeAux.tab[i8] = i9;
            decodeAux.tabl[i8] = i10;
        }
        return decodeAux;
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* loaded from: com_jcraft_jorbis.jar:com/jcraft/jorbis/CodeBook$DecodeAux.class */
    public class DecodeAux {
        int[] tab;
        int[] tabl;
        int tabn;
        int[] ptr0;
        int[] ptr1;
        int aux;

        DecodeAux() {
        }
    }
}
